MONGOFILES(1)

NAME
mongofiles - MongoDB

SYNOPSIS

The mongofiles utility makes it possible to manipulate files stored in your MongoDB instance in GridFS objects from the command line. It is particularly useful as it provides an interface between objects stored in your file system and GridFS.

All mongofiles commands take arguments in three groups:

    1.  Options. You may use one or more of these options to control the behavior of mongofiles.

    2.  Commands. Use one of these commands to determine the action of mongofiles.

    3.  A file name representing either the name of a file on your system's file system, a GridFS object.

mongofiles, like mongodump, mongoexport, mongoimport, and mongorestore, can access data stored in a MongoDB data directory without requiring a running mongod instance, if no other mongod is running.

Note
    For replica sets, mongofiles can only read from the set's 'primary.

COMMANDS

    mongofiles

    list <prefix>
        Lists the files in the GridFS store. The characters specified after list (e.g. <prefix>) optionally limit the list of returned items to files that begin with that string of characters.

    search <string>
        Lists the files in the GridFS store with names that match any portion of <string>.

    put <filename>
        Copy the specified file from the local file system into GridFS storage.

        Here, <filename> refers to the name the object will have in GridFS, and mongofiles assumes that this reflects the name the file has on the local file system. If the local filename is different use the mongofiles --local option.

    get <filename>
        Copy the specified file from GridFS storage to the local file system.

        Here, <filename> refers to the name the object will have in GridFS, and mongofiles assumes that this reflects the name the file has on the local file system. If the local filename is different use the mongofiles --local option.

    delete <filename>
        Delete the specified file from GridFS storage.

OPTIONS

    --help
        Returns a basic help and usage text.

    --verbose, -v
        Increases the amount of internal reporting returned on the command line. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

    --version
        Returns the version of the mongofiles utility.

    --host <hostname><:port>
        Specifies a resolvable hostname for the mongod that holds your GridFS system. By default mongofiles attempts to connect to a MongoDB process ruining on the localhost port number 27017.

        Optionally, specify a port number to connect a MongoDB instance running on a port other than 27017.

    --port <port>
        Specifies the port number, if the MongoDB instance is not running on the standard port. (i.e. 27017) You may also specify a port number using the mongofiles --host command.

    --ipv6
        Enables IPv6 support that allows mongofiles to connect to the MongoDB instance using an IPv6 network. All MongoDB programs and processes, including mongofiles, disable IPv6 support by default.

    --ssl
        New in version 2.4: MongoDB added support for SSL connections to mongod instances in mongofiles.

    Note
        SSL support in mongofiles is not compiled into the default distribution of MongoDB. See /administration/ssl for more information on SSL and MongoDB.

        Additionally, mongofiles does not support connections to mongod instances that require client certificate validation.

Allows mongofiles to connect to mongod instance over an SSL connection.

    --username <username>, -u <username>
        Specifies a username to authenticate to the MongoDB instance, if your database requires authentication. Use in conjunction with the mongofiles --password option to supply a password.

    --password <password>, -p <password>
        Specifies a password to authenticate to the MongoDB instance. Use in conjunction with the mongofiles --username option to supply a username.

        If you specify a --username without the --password option, mongofiles will prompt for a password interactively.

    --authenticationDatabase <dbname>
        New in version 2.4.

        Specifies the database that holds the user's (e.g --username) credentials.

        By default, mongofiles assumes that the database specified to the --db argument holds the user's credentials, unless you specify --authenticationDatabase.

        See userSource, /reference/privilege-documents and /reference/user-privileges for more information about delegated authentication in MongoDB.

    --authenticationMechanism <name>
        New in version 2.4.

        Specifies the authentication mechanism. By default, the authentication mechanism is MONGODB-CR, which is the MongoDB challenge/response authentication mechanism. In the MongoDB Subscriber Edition, mongofiles also includes support for GSSAPI to handle Kerberos authentication.

        See /tutorial/control-access-to-mongodb-with-kerberos-authentication for more information about Kerberos authentication.

    --dbpath <path>
        Specifies the directory of the MongoDB data files. If used, the --dbpath option enables mongofiles to attach directly to local data files interact with the GridFS data without the mongod. To run with --dbpath, mongofiles needs to lock access to the data directory: as a result, no mongod can access the same path while the process runs.

    --directoryperdb
        Use the --directoryperdb in conjunction with the corresponding option to mongod, which allows mongofiles when running with the --dbpath option and MongoDB uses an on-disk format where every database has a distinct directory. This option is only relevant when specifying the --dbpath option.

    --journal
        Allows mongofiles operations to use the durability journal when running with --dbpath to ensure that the database maintains a recoverable state. This forces mongofiles to record all data on disk regularly.

    --db <db>, -d <db>
        Use the --db option to specify the MongoDB database that stores or will store the GridFS files.

    --collection <collection>, -c <collection>
        This option has no use in this context and a future release may remove it. See SERVER-4931 for more information.

    --local <filename>, -l <filename>
        Specifies the local filesystem name of a file for get and put operations.

        In the mongofiles put and mongofiles get commands the required <filename> modifier refers to the name the object will have in GridFS. mongofiles assumes that this reflects the file's name on the local file system. This setting overrides this default.

    --type <MIME>, t <MIME>
        Provides the ability to specify a MIME type to describe the file inserted into GridFS storage. mongofiles omits this option in the default operation.

        Use only with mongofiles put operations.

    --replace, -r
        Alters the behavior of mongofiles put to replace existing GridFS objects with the specified local file, rather than adding an additional object with the same name.

        In the default operation, files will not be overwritten by a mongofiles put option.

USE

To return a list of all files in a GridFS collection in the records database, use the following invocation at the system shell:

mongofiles -d records list

This mongofiles instance will connect to the mongod instance running on the 27017 localhost interface to specify the same operation on a different port or hostname, and issue a command that resembles one of the following:

mongofiles --port 37017 -d records list
mongofiles --hostname db1.example.net -d records list
mongofiles --hostname db1.example.net --port 37017 -d records list

Modify any of the following commands as needed if you're connecting the mongod instances on different ports or hosts.

To upload a file named 32-corinth.lp to the GridFS collection in the records database, you can use the following command:

mongofiles -d records put 32-corinth.lp

To delete the 32-corinth.lp file from this GridFS collection in the records database, you can use the following command:

mongofiles -d records delete 32-corinth.lp

To search for files in the GridFS collection in the records database that have the string corinth in their names, you can use following command:

mongofiles -d records search corinth

To list all files in the GridFS collection in the records database that begin with the string 32, you can use the following command:

mongofiles -d records list 32

To fetch the file from the GridFS collection in the records database named 32-corinth.lp, you can use the following command:

mongofiles -d records get 32-corinth.lp

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2011-2013, 10gen, Inc.